;Dance Revolution
;Jubei - 2/7/02 - 2/12/02
;bobasaurus@hotmail.com

.nolist
#include	"ion.inc"
.list

#ifdef TI83P
	.org	progstart-2
	.dw	$6DBB
#else
	.org	progstart
#endif


storage		=sram
ycord1		=storage+1
startcount	=storage+2
wait3		=storage+3
waitcount2	=storage+4
wait1		=storage+5
wait2		=storage+6
waitcount	=storage+7
rem1		=storage+8
rem2		=storage+9
rem3		=storage+10
rem4		=storage+11
rem5		=storage+12
rem6		=storage+13
rem7		=storage+14
rem8		=storage+15
score		=storage+17
speed		=storage+19
boolean		=storage+20
speedcount	=storage+21
rem0		=storage+22
missnum		=storage+23
totalscore	=storage+25

	ret
	jr	nc,start_of_program
description:
	.db	"Dance Revolution",0
start_of_program:

	ld a,56			;variables are initialized
	ld (ycord1),a
	xor a
	ld (waitcount),a
	ld (rem0),a
	ld (rem1),a
	ld (rem2),a
	ld (rem3),a
	ld (rem4),a
	ld (rem5),a
	ld (rem6),a
	ld (rem7),a
	ld (rem8),a
	ld (score),a
	ld h,a
	ld l,a
	ld (boolean),a
	ld (speedcount),a
	ld (missnum),a

	ld a,38			;higher number = slower speed.  Has to be even.
	ld (speed),a

menu:				;starting menu
	bcall(_GRBUFCLR)
	call ionFastCopy
	ld bc,$0033
	ld de,$5E33
	bcall(_darkline)

	ld bc,$0031
	ld de,$5E31
	bcall(_darkline)

	ld bc,$003F
	ld de,$5E3F
	bcall(_darkline)

	ld bc,$003D
	ld de,$5E3D
	bcall(_darkline)

	ld hl,16
	ld (pencol),hl
	ld hl,4
	ld (penrow),hl
	ld hl,opening
	bcall(_vputs)

	ld hl,24
	ld (pencol),hl
	ld hl,30
	ld (penrow),hl
	ld hl,secondtext
	bcall(_vputs)

	ld bc,$181A
	ld de,$3D1A
	bcall(_darkline)

	ld hl,0
	ld (pencol),hl
	ld hl,51
	ld (penrow),hl
	ld hl,bytext
	bcall(_vputs)

	ld hl,0
	ld (pencol),hl
	ld hl,57
	ld (penrow),hl
	ld hl,emailtext
	bcall(_vputs)


menu2:

	ld a,0ffh		;check for 2nd press
	out (1),a
	ld a,0bfh
	out (1),a
	in a,(1)
	cp 223
	jr z,start
	
	ld a,0ffh		;check for clear press
	out (1),a
	ld a,0fdh
	out (1),a
	in a,(1)
	cp 191
	jp z,quickend

	jr menu2
quickend:
	ret

start:				;start of main program
	call drawscreen

	xor a			;reset a counter and a boolean
	ld (startcount),a
	ld (boolean),a
startloop:			;loop for delaying arrow movement
	call waitloop
	ld a,(startcount)
	inc a
	ld (startcount),a
	ld b,a
	ld a,(speed)		;checks if the counter = the speed #
	sub b
	cp 0
	jr z,startloop2

	ld a,0ffh		;checks for direction presses
	out (1),a
	ld a,0feh
	out (1),a
	in a,(1)
	cp 253
	call z,leftdir
	cp 254
	call z,downdir
	cp 247
	call z,updir
	cp 251
	call z,rightdir

	ld a,0ffh		;checks for clear press to end program
	out (1),a
	ld a,0fdh
	out (1),a
	in a,(1)
	cp 191
	jp z,end

	jr startloop
startloop2:
	
	ld a,0ffh		;checks for clear
	out (1),a
	ld a,0fdh
	out (1),a
	in a,(1)
	cp 191
	jp z,end

	ld a,0ffh		;checks for direction presses
	out (1),a
	ld a,0feh
	out (1),a
	in a,(1)
	cp 253
	call z,leftdir
	cp 254
	call z,downdir
	cp 247
	call z,updir
	cp 251
	call z,rightdir

	ld a,(speedcount)	;slowly increments speed
	inc a
	ld (speedcount),a
	cp 18
	call z,speedincrease

	ld a,(rem1)		;check used for error count
	cp 0
	call nz,miss
	
	ld a,(score)
	cp 250
	jp z,end

	ld a,(rem1)		;string of vars for remembering arrow positions
	ld (rem0),a
	ld a,(rem2)
	ld (rem1),a
	ld a,(rem3)
	ld (rem2),a
	ld a,(rem4)
	ld (rem3),a
	ld a,(rem5)
	ld (rem4),a
	ld a,(rem6)
	ld (rem5),a
	ld a,(rem7)
	ld (rem6),a
	ld a,(rem8)
	ld (rem7),a

	jp start

speedincrease:			;increases speed (duh...)
	xor a
	ld (speedcount),a
	ld a,(speed)
	sub 2
	cp 10			;makes sure speed doesn't increase insanely
	ret z
	ld (speed),a
	ret
miss:
	ld a,(missnum)
	inc a
	ld (missnum),a

	ld hl,3			;displays new error number
	ld (currow),hl
	ld hl,7
	ld (curcol),hl
	ld a,(missnum)
	ld l,a
	bcall(_dispHL)
	ret
end:				;tallies scores and exits program
	
	bcall(_GRBUFCLR)	;clear screen
	call ionFastCopy

	ld hl,10
	ld (pencol),hl
	ld hl,0
	ld (penrow),hl
	ld hl,scoretext
	bcall(_vputs)

	ld hl,1
	ld (currow),hl
	ld hl,0
	ld (curcol),hl
	ld a,(score)
	ld l,a
	bcall(_dispHL)

	ld hl,10
	ld (pencol),hl
	ld hl,16
	ld (penrow),hl
	ld hl,misstext
	bcall(_vputs)

	ld hl,3
	ld (currow),hl
	ld hl,0
	ld (curcol),hl
	ld a,(missnum)
	ld l,a
	bcall(_dispHL)

	ld hl,45
	ld (pencol),hl
	ld hl,0
	ld (penrow),hl
	ld hl,totalscoretext
	bcall(_vputs)

	ld a,(missnum)		;calculates total score
	ld b,a
	ld a,(score)
	sub b
	call c,zeroscore
	ld (totalscore),a
	
	ld hl,1
	ld (currow),hl
	ld hl,9
	ld (curcol),hl
	ld a,(totalscore)
	ld l,a
	bcall(_dispHL)

	ld hl,45
	ld (pencol),hl
	ld hl,16
	ld (penrow),hl
	ld hl,highscoretext
	bcall(_vputs)

	ld a,(totalscore)	;checks if it's a new highscore
	ld b,a
	ld a,(highscore)
	sub b
	call c,highscorechange

	ld hl,3
	ld (currow),hl
	ld hl,9
	ld (curcol),hl
	ld a,(highscore)
	ld l,a
	bcall(_dispHL)

	call waitloop		;slight pause so it won't exit immediately if clear is held
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop
	call waitloop

end2:

	ld a,0ffh		;checks for 2nd to exit
	out (1),a
	ld a,0bfh
	out (1),a
	in a,(1)
	cp 223
	ret z
	
	ld a,0ffh		;checks for clear to exit
	out (1),a
	ld a,0fdh
	out (1),a
	in a,(1)
	cp 191
	ret z

	jp end2

highscorechange:		;sets new high score
	ld a,(totalscore)
	ld (highscore),a
	ret
zeroscore:
	ld a,0
	ld (totalscore),a
	ret

leftdir:
	ld a,(boolean)		;boolean so people can't just hold down a direction and rack up huge points
	cp 1
	ret z
	ld a,1
	ld (boolean),a

	ld a,(rem1)		;checks if button press equals arrow location
	cp 1
	call z,scoreadd

	ret
downdir:
	ld a,(boolean)
	cp 1
	ret z
	ld a,1
	ld (boolean),a

	ld a,(rem1)
	cp 2
	call z,scoreadd

	ret
updir:
	ld a,(boolean)
	cp 1
	ret z
	ld a,1
	ld (boolean),a

	ld a,(rem1)
	cp 3
	call z,scoreadd

	ret
rightdir:
	ld a,(boolean)
	cp 1
	ret z
	ld a,1
	ld (boolean),a

	ld a,(rem1)
	cp 4
	call z,scoreadd

	ret
scoreadd:			;increments score
	xor a			;used for error check
	ld (rem1),a

	ld a,(score)
	inc a
	ld (score),a
	ld hl,1			;displays score
	ld (currow),hl
	ld hl,7
	ld (curcol),hl
	ld a,(score)
	ld l,a
	bcall(_dispHL)
	ret

drawscreen:			;where everything is drawn
	bcall(_GRBUFCLR)	;screen cleared and top arrows are drawn
	ld ix,firstsprite
	ld l,0
	ld b,8
	ld c,5
	ld a,0
	call ionLargeSprite

	ld b,5			;random number for arrow generating
	call ionRandom
	ld (rem8),a

	call drawtherest	;draws all the arrows minus the top ones

	
	ld a,(rem1)		;makes it so arrows at top change when you have to press them
	cp 1
	call z,draw1
	cp 2
	call z,draw2
	cp 3
	call z,draw3
	cp 4
	call z,draw4


	call ionFastCopy	;copies graph buffer (where everything is drawn) to the screen

	ld hl,50		;displays numbers to the right
	ld (pencol),hl
	ld hl,0
	ld (penrow),hl
	ld hl,scoretext
	bcall(_vputs)

	ld hl,1
	ld (currow),hl
	ld hl,7
	ld (curcol),hl
	ld a,(score)
	ld l,a
	bcall(_dispHL)

	ld hl,50
	ld (pencol),hl
	ld hl,16
	ld (penrow),hl
	ld hl,misstext
	bcall(_vputs)

	ld hl,3
	ld (currow),hl
	ld hl,7
	ld (curcol),hl
	ld a,(missnum)
	ld l,a
	bcall(_dispHL)

	ret

drawtherest:			;draws all arrows but the top ones

	ld a,(rem8)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,(ycord1)
	sub 8
	ld (ycord1),a

	ld a,(rem7)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,(ycord1)
	sub 8
	ld (ycord1),a

	ld a,(rem6)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,(ycord1)
	sub 8
	ld (ycord1),a

	ld a,(rem5)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,(ycord1)
	sub 8
	ld (ycord1),a

	ld a,(rem4)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,(ycord1)
	sub 8
	ld (ycord1),a

	ld a,(rem3)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,(ycord1)
	sub 8
	ld (ycord1),a

	ld a,(rem2)
	cp 0
	call z,drawline
	cp 1
	call z,one
	cp 2
	call z,two
	cp 3
	call z,three
	cp 4
	call z,four

	ld a,56
	ld (ycord1),a

	ret

one:
	ld ix,left
	ld a,(ycord1)
	ld l,a
	ld b,8
	ld a,0
	call ionPutSprite
	
	call drawline
	ret
two:
	ld ix,down
	ld a,(ycord1)
	ld l,a
	ld b,8
	ld a,8
	call ionPutSprite

	call drawline
	ret
three:
	ld ix,up
	ld a,(ycord1)
	ld l,a
	ld b,8
	ld a,17
	call ionPutSprite

	call drawline
	ret
four:
	ld ix,right
	ld a,(ycord1)
	ld l,a
	ld b,8
	ld a,25
	call ionPutSprite

	call drawline
	ret
drawline:			;line in the middle of the screen
	ld ix,line
	ld a,(ycord1)
	ld l,a
	ld b,8
	ld a,33
	call ionPutSprite
	ret


waitloop:			;delay loop
	xor a
	ld (wait1),a
	ld (wait2),a
	ld (wait3),a
	ld (waitcount),a
	ld (waitcount2),a
waitloop1:
	xor a
	ld (wait2),a
	ld (waitcount2),a
	ld a,(wait1)
	inc a
	ld (wait1),a
	cp 255
	call z,waitloop2
	ld a,(waitcount)
	inc a
	ld (waitcount),a
	cp 255
	ret z
	jr waitloop1
waitloop2:
	xor a
	ld (wait1),a
	ld a,(wait2)
	inc a
	ld (wait2),a
	cp 255
	call z,waitloop3
	ld a,(waitcount2)
	inc a
	ld (waitcount2),a
	cp 255
	ret z
	jr waitloop2
waitloop3:
	xor a
	ld (wait2),a
	ld a,(wait3)
	inc a
	ld (wait3),a
	cp 255
	ret z
	jr waitloop3
draw1:
	ld ix,halffull1
	ld l,0
	ld b,8
	ld a,0
	call ionPutSprite
	ret
draw2:
	ld ix,halffull2
	ld l,0
	ld b,8
	ld a,8
	call ionPutSprite
	ret
draw3:
	ld ix,halffull3
	ld l,0
	ld b,8
	ld a,17
	call ionPutSprite
	ret
draw4:
	ld ix,halffull4
	ld l,0
	ld b,8
	ld a,25
	call ionPutSprite
	ret
	
left:				;all the sprites (graphics)
 .db %00010000
 .db %00110000
 .db %01011111
 .db %10000001
 .db %01011111
 .db %00110000
 .db %00010000
 .db %00000000
down:
 .db %00011100
 .db %00010100
 .db %00010100
 .db %00010100
 .db %01110111
 .db %00100010
 .db %00010100
 .db %00001000
up:
 .db %00010000
 .db %00101000
 .db %01000100
 .db %11101110
 .db %00101000
 .db %00101000
 .db %00101000
 .db %00111000
right:
 .db %00001000
 .db %00001100
 .db %11111010
 .db %10000001
 .db %11111010
 .db %00001100
 .db %00001000
 .db %00000000
firstsprite:
 .db %00010000, %00011100, %00001000, %00000100, %00001100
 .db %00110000, %00010100, %00010100, %00000110, %00001100
 .db %01011111, %00010100, %00100010, %01111101, %00001100
 .db %10000001, %00010100, %01110111, %01000000, %10001100
 .db %01011111, %01110111, %00010100, %01111101, %00001100
 .db %00110000, %00100010, %00010100, %00000110, %00001100
 .db %00010000, %00010100, %00010100, %00000100, %00001100
 .db %00000000, %00001000, %00011100, %00000000, %00001100
line:
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
 .db %00011000
halffull1:
 .db %00000000
 .db %00000000
 .db %00100000
 .db %01110000
 .db %00100000
 .db %00000000
 .db %00000000
 .db %00000000
halffull2:
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00001000
 .db %00011100
 .db %00001000
 .db %00000000

halffull3:
 .db %00000000
 .db %00010000
 .db %00111000
 .db %00010000
 .db %00000000
 .db %00000000
 .db %00000000
 .db %00000000
halffull4:
 .db %00000000
 .db %00000000
 .db %00000100
 .db %00001110
 .db %00000100
 .db %00000000
 .db %00000000
 .db %00000000

				;all the text

scoretext:			
	.db	"Score: ",0
misstext:
	.db	"Misses: ",0
opening:
	.db	"Dance Revolution",0
secondtext:
	.db	"2nd to Start",0
bytext:
	.db	"By Jubei",0
emailtext:
	.db	"bobasaurus@hotmail.com"
totalscoretext:
	.db	"Total Score: ",0
highscoretext:
	.db	"High Score: ",0

				;high score is kept here
highscore:
	.dw	0

.end
